package bar_multi_klausurplaner_cnf;

import java.io.Serializable;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.TreeSet;

/**
 * @author Benjamin A. Bartsch
 */
public class D_Map implements Serializable {

    private static final long serialVersionUID = 1L;

    private final HashMap<Object, D_Map> map = new HashMap<>();

    boolean has(Object obj) {
        return map.containsKey(obj);
    }

    D_Map get(Object obj) {
        if (!map.containsKey(obj)) {
            map.put(obj, new D_Map());
        }
        return map.get(obj);
    }

    String first_key_string() {
        return (String) map.keySet().iterator().next();
    }

    int first_key_int() {
        return (Integer) map.keySet().iterator().next();
    }

    boolean[][] first_key_boolean_2d() {
        return (boolean[][]) map.keySet().iterator().next();
    }

    String[][] first_key_string_2d() {
        return (String[][]) map.keySet().iterator().next();
    }

    Iterable keySet() {
        return map.keySet();
    }

    /*LinkedList<String> keySetString() {
        LinkedList<String> list = new LinkedList<>();
        for (Object obj : this.keySet()) {
            list.addLast((String) obj);
        }
        return list;
    }*/

    TreeSet keySetSorted() {
        return new TreeSet<>(map.keySet());
    }

    TreeSet<String> keySetSortedString() {
        TreeSet<String> set = new TreeSet<>();
        for (Object obj : this.keySetSorted()) {
            set.add((String) obj);
        }
        return set;
    }

    TreeSet<Integer> keySetSortedInteger() {
        TreeSet<Integer> set = new TreeSet<>();
        for (Object obj : this.keySetSorted()) {
            set.add((Integer) obj);
        }
        return set;
    }

    TreeSet<String> keySetSortedDate() {
        TreeSet<String> set = new TreeSet<>(new Comparator<String>() {
            @Override
            public int compare(String a, String b) {
                try {
                    SimpleDateFormat sdf = new SimpleDateFormat(Static.DATE_FORMAT);
                    Date da = sdf.parse(a);
                    Date db = sdf.parse(b);
                    return da.compareTo(db);
                } catch (ParseException ex) {
                    return a.compareTo(b);
                }
            }
        });
        set.addAll(keySetSortedString());
        return set;
    }

    LinkedList<Integer> keySetInteger() {
        LinkedList<Integer> list = new LinkedList<>();
        for (Object obj : this.keySet()) {
            list.addLast((Integer) obj);
        }
        return list;
    }

    int size() {
        return map.size();
    }

    void clear() {
        map.clear();
    }

    void retain_key_max() {
        TreeSet<Object> set = keySetSorted();
        set.pollLast();
        while (set.isEmpty() == false) {
            map.remove(set.pollFirst());
        }
    }

    D_Map copy() {
        D_Map mapCopy = new D_Map();
        for (Object key : map.keySet()) {
            mapCopy.map.put(key, map.get(key).copy());
        }
        return mapCopy;
    }

    void del(Object key) {
        map.remove(key);
    }

}
